static const char *RcsId = "$Header: /home/cvsadm/cvsroot/fermi/servers/alarmtest/src/AlarmTest.cpp,v 1.2 2013-10-29 13:22:03 graziano Exp $";
//+=============================================================================
//
// file :         AlarmTest.cpp
//
// description :  C++ source for the AlarmTest and its commands. 
//                The class is derived from Device. It represents the
//                CORBA servant object which will be accessed from the
//                network. All commands which can be executed on the
//                AlarmTest are implemented in this file.
//
// project :      TANGO Device Server
//
// $Author: graziano $
//
// $Revision: 1.2 $
//
// $Log: AlarmTest.cpp,v $
// Revision 1.2  2013-10-29 13:22:03  graziano
// Device_4Impl
//
// Revision 1.1  2013-10-29 13:20:02  graziano
// *** empty log message ***
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================



//===================================================================
//
//	The following table gives the correspondence
//	between commands and method name.
//
//  Command name|  Method name
//	----------------------------------------
//  State   |  dev_state()
//  Status  |  dev_status()
//
//===================================================================


#include <tango.h>
#include <AlarmTest.h>
#include <AlarmTestClass.h>

namespace AlarmTest_ns
{

//+----------------------------------------------------------------------------
//
// method : 		AlarmTest::AlarmTest(string &s)
// 
// description : 	constructor for simulated AlarmTest
//
// in : - cl : Pointer to the DeviceClass object
//      - s : Device name 
//
//-----------------------------------------------------------------------------
AlarmTest::AlarmTest(Tango::DeviceClass *cl,string &s)
:Tango::Device_4Impl(cl,s.c_str())
{
	init_device();
}

AlarmTest::AlarmTest(Tango::DeviceClass *cl,const char *s)
:Tango::Device_4Impl(cl,s)
{
	init_device();
}

AlarmTest::AlarmTest(Tango::DeviceClass *cl,const char *s,const char *d)
:Tango::Device_4Impl(cl,s,d)
{
	init_device();
}
//+----------------------------------------------------------------------------
//
// method : 		AlarmTest::delete_device()
// 
// description : 	will be called at device destruction or at init command.
//
//-----------------------------------------------------------------------------
void AlarmTest::delete_device()
{
	//	Delete device's allocated object
	delete attr_Alarm_test_read;
}

//+----------------------------------------------------------------------------
//
// method : 		AlarmTest::init_device()
// 
// description : 	will be called at device initialization.
//
//-----------------------------------------------------------------------------
void AlarmTest::init_device()
{
	INFO_STREAM << "AlarmTest::AlarmTest() create device " << device_name << endl;

	// Initialise variables to default values
	//--------------------------------------------
	attr_Alarm_test_read = new Tango::DevBoolean;
	*attr_Alarm_test_read = 0;
	attr_Alarm_test_write = 0;
	set_change_event("alarm_test", true, false);		//attribute name, implemented, detect, if not setting detect=false have to set abs_change or rel_change for each attribute
	Tango::MultiAttribute *attr_list = get_device_attr();
	Tango::WAttribute &attr = attr_list->get_w_attr_by_name ("alarm_test"); 
	attr.set_write_value(attr_Alarm_test_write);
	Alarm_test_push_val = attr_Alarm_test_write;
	push_change_event("Alarm_test", &Alarm_test_push_val);
}

//+----------------------------------------------------------------------------
//
// method : 		AlarmTest::always_executed_hook()
// 
// description : 	method always executed before any command is executed
//
//-----------------------------------------------------------------------------
void AlarmTest::always_executed_hook()
{
	
}
//+----------------------------------------------------------------------------
//
// method : 		AlarmTest::read_attr_hardware
// 
// description : 	Hardware acquisition for attributes.
//
//-----------------------------------------------------------------------------
void AlarmTest::read_attr_hardware(vector<long> &attr_list)
{
	DEBUG_STREAM << "AlarmTest::read_attr_hardware(vector<long> &attr_list) entering... "<< endl;
	//	Add your own code here
}

//+----------------------------------------------------------------------------
//
// method : 		AlarmTest::read_Alarm_test
// 
// description : 	Extract real attribute values for Alarm_test acquisition result.
//
//-----------------------------------------------------------------------------
void AlarmTest::read_Alarm_test(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AlarmTest::read_Alarm_test(Tango::Attribute &attr) entering... "<< endl;
	//*attr_Alarm_test_read = ;
	attr.set_value(attr_Alarm_test_read);	
}

//+----------------------------------------------------------------------------
//
// method : 		AlarmTest::write_Alarm_test
// 
// description : 	Write Alarm_test attribute values to hardware.
//
//-----------------------------------------------------------------------------
void AlarmTest::write_Alarm_test(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AlarmTest::write_Alarm_test(Tango::WAttribute &attr) entering... "<< endl;
	attr.get_write_value(attr_Alarm_test_write);
	*attr_Alarm_test_read = attr_Alarm_test_write;
	Alarm_test_push_val = attr_Alarm_test_write;
	push_change_event("Alarm_test", &Alarm_test_push_val);
}




}	//	namespace
