//=============================================================================
//
// file :         AlarmTestClass.h
//
// description :  Include for the AlarmTestClass root class.
//                This class is represents the singleton class for
//                the AlarmTest device class.
//                It contains all properties and methods which the 
//                AlarmTest requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: graziano $
//
// $Revision: 1.1 $
//
// $Log: AlarmTestClass.h,v $
// Revision 1.1  2012-06-21 07:05:43  graziano
// first commit
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _ALARMTESTCLASS_H
#define _ALARMTESTCLASS_H

#include <tango.h>
#include <AlarmTest.h>


namespace AlarmTest_ns
{//=====================================
//	Define classes for attributes
//=====================================
class Alarm_testAttrib: public Tango::Attr
{
public:
	Alarm_testAttrib():Attr("Alarm_test", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~Alarm_testAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AlarmTest *>(dev))->read_Alarm_test(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<AlarmTest *>(dev))->write_Alarm_test(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AlarmTest *>(dev))->is_Alarm_test_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
//
// The AlarmTestClass singleton definition
//

class
#ifdef WIN32
	__declspec(dllexport)
#endif
	AlarmTestClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static AlarmTestClass *init(const char *);
	static AlarmTestClass *instance();
	~AlarmTestClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	AlarmTestClass(string &);
	static AlarmTestClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace AlarmTest_ns

#endif // _ALARMTESTCLASS_H
